>From d65d292a7adbb659846bdd91615503ff96c40ccb Mon Sep 17 00:00:00 2001
From: Stefan Tauner <stefan.tauner@student.tuwien.ac.at>
Date: Thu, 9 Feb 2012 20:33:50 +0100
Subject: [PATCH 2/2] fixup! Add support for SFDP (JESD216).

suggested simplified 4k handling

Signed-off-by: Stefan Tauner <stefan.tauner@student.tuwien.ac.at>
---
 sfdp.c |   15 +++------------
 1 files changed, 3 insertions(+), 12 deletions(-)

diff --git a/sfdp.c b/sfdp.c
index 397c8af..70f2872 100644
--- a/sfdp.c
+++ b/sfdp.c
@@ -116,7 +116,6 @@ static int sfdp_fill_flash(struct flashctx *flash, uint8_t *buf, uint16_t len)
 	uint32_t tmp32;
 	uint8_t tmp8;
 	uint32_t total_size; /* in bytes */
-	uint8_t opcode_4k = 0xFF;
 	uint32_t block_size;
 	int dw, j;
 
@@ -179,7 +178,7 @@ static int sfdp_fill_flash(struct flashctx *flash, uint8_t *buf, uint16_t len)
 	}
 
 	if ((tmp32 & 0x3) == 0x1) {
-		opcode_4k = (tmp32 >> 8) & 0xFF; /* will be dealt with later */
+		sfdp_add_uniform_eraser(flash, (tmp32 >> 8) & 0xFF, 4 * 1024);
 	}
 
 	/* 2. double word */
@@ -203,7 +202,7 @@ static int sfdp_fill_flash(struct flashctx *flash, uint8_t *buf, uint16_t len)
 		msg_cdbg("It seems like this chip supports the preliminary "
 			 "Intel version of SFDP, skipping processing of double "
 			 "words 3-9.\n");
-		goto proc_4k;
+		goto done;
 	}
 
 	dw = 8;
@@ -224,17 +223,9 @@ static int sfdp_fill_flash(struct flashctx *flash, uint8_t *buf, uint16_t len)
 		tmp8 = buf[(4 * dw) + (2 * j) + 1];
 		if (sfdp_add_uniform_eraser(flash, tmp8, block_size))
 			continue;
-		/* If there is a valid 4k value in the last double words,
-		 * we want to override the value from double word 1, hence force
-		 * skipping its processing: */
-		if (block_size == 4 * 1024 && tmp8 == opcode_4k)
-			opcode_4k = 0xFF;
 	}
 
-proc_4k:
-	if (opcode_4k != 0xFF) {
-		sfdp_add_uniform_eraser(flash, opcode_4k, 4 * 1024);
-	}
+done:
 	msg_cdbg("done.\n");
 	return 0;
 }
-- 
1.7.1

